#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480
#define DEG_TO_RAD(_x)  ((_x) * M_PI / 180.0)

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Circle 6", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    int centerX = SCREEN_WIDTH / 2;
    int centerY = SCREEN_HEIGHT / 2;
    int radius = 200;

    for (int i = 0; i < 360; i++)
    {
        for (int j = -90; j <= 90; j += 10)
        {
            float angleAdd = DEG_TO_RAD(j);

            float angle0 = DEG_TO_RAD(i);
            int x0 = centerX + radius * cos(angle0 + angleAdd);
            int y0 = centerY + radius * sin(angle0);

            float angle1 = DEG_TO_RAD(i + 1);
            int x1 = centerX + radius * cos(angle1 + angleAdd);
            int y1 = centerY + radius * sin(angle1);

            gfx.line(x0, y0, x1, y1, Color(255, 255, 255));
        }

        gfx.render();
        sys.wait(20);
    }

    // wait until we quit
    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
